#include "stdafx.h"
#include "Config.h"
#include "IniUtil.h"

#define APP_SECTION			_T("JTLPCHGEXEC")
#define APP_ONLP_APP		_T("LANDSCAPE_APP")
#define APP_ONLP_ARGS		_T("LANDSCAPE_ARGS")
#define APP_ONPT_APP		_T("PORTRAIT_APP")
#define APP_ONPT_ARGS		_T("PORTRAIT_ARGS")

static
LPWSTR
LoadIniString(
	HANDLE	hRef,
	LPTSTR	pSection,
	LPTSTR	pKey
)
{
	DWORD	dwSize;
	LPTSTR	pRetStr = NULL;

	dwSize = 0;
	if (IniUtilGetString(hRef, pSection, pKey, NULL, &dwSize)) {
		pRetStr = (LPTSTR)malloc(dwSize*sizeof(WCHAR));
		if (pRetStr != NULL) {
			if (IniUtilGetString(hRef, pSection, pKey, pRetStr, &dwSize)) {
				;
			}
			else {
				free(pRetStr);
				pRetStr = NULL;
			}
		}
	}

	return pRetStr;
}


BOOL
LoadConfigData(
	LPTSTR		pFilePath,
	CONFIGDATA*	pConfigData
)
{
	BOOL	bRet;
	HANDLE	hRef = NULL;

	bRet = FALSE;	// default return value

	if (pFilePath == NULL || pConfigData == NULL) {
		return FALSE;
	}

	hRef = IniUtilCreateRef();
	if (hRef != NULL) {
		if (IniUtilLoadFile(hRef, pFilePath)) {

			pConfigData->pOnLandscapeApp	= LoadIniString(hRef, APP_SECTION, APP_ONLP_APP);
			pConfigData->pOnLandscapeArgs	= LoadIniString(hRef, APP_SECTION, APP_ONLP_ARGS);
			pConfigData->pOnPortraitApp		= LoadIniString(hRef, APP_SECTION, APP_ONPT_APP);
			pConfigData->pOnPortraitArgs	= LoadIniString(hRef, APP_SECTION, APP_ONPT_ARGS);

			bRet = TRUE;
		}

		IniUtilDeleteRef(hRef);
		hRef = NULL;
	}

	return bRet;
}

void
DiscardConfigData(
	CONFIGDATA*	pConfigData
)
{
	if (pConfigData != NULL) {
		if (pConfigData->pOnLandscapeApp != NULL) {
			free(pConfigData->pOnLandscapeApp);
			pConfigData->pOnLandscapeApp = NULL;
		}
		if (pConfigData->pOnLandscapeArgs != NULL) {
			free(pConfigData->pOnLandscapeArgs);
			pConfigData->pOnLandscapeArgs = NULL;
		}
		if (pConfigData->pOnPortraitApp != NULL) {
			free(pConfigData->pOnPortraitApp);
			pConfigData->pOnPortraitApp = NULL;
		}
		if (pConfigData->pOnPortraitArgs != NULL) {
			free(pConfigData->pOnPortraitArgs);
			pConfigData->pOnPortraitArgs = NULL;
		}
	}
}