// JTLPChgExec.cpp : DLL AvP[Vp̃Gg |Cg`܂B
//

#include "stdafx.h"
#include "JTPlugin.h"
#include "Config.h"

/* Defines */
#define APP_CLASS_NAME			_T("JTLPChgExec Application Class")
#define APP_TITLE_NAME			_T("JTLPChgExec Application")
#define CONFIGFILE_NAME			_T("JTLPChgExec.ini")
#define WM_APPEND_REQUEST		(WM_APP + 1)
#define WM_RELOADCONFIG_REQUEST	(WM_APP + 2)

/* ProtoTypes */
static ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
static LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);

/* Typedefs */
typedef struct _WNDTHREAD_PARAM {
	BOOL	bSuccess;
	HANDLE	hEvent;
} WNDTHREAD_PARAM;


/* Global Variables */
HMODULE	g_hModule	= NULL;
HANDLE	g_hThread	= NULL;


static
BOOL
GetIniPath(
	HMODULE		hModule,
	LPTSTR		pPath
)
{
	BOOL	bRet;
	TCHAR	szPath[MAX_PATH + 1];
	LPTSTR	p = NULL;

	bRet = FALSE;

	if (pPath == NULL) {
		return FALSE;
	}

	memset(szPath, 0, sizeof(szPath));
	GetModuleFileName(hModule, szPath, sizeof(szPath)/sizeof(szPath[0]));

	p = _tcsrchr(szPath, _T('\\'));
	if (p != NULL) {
		*(p+1) = _T('\0');

		_tcscpy(pPath, szPath);
		_tcscat(pPath, CONFIGFILE_NAME);

		bRet = TRUE;
	}

	return bRet;
}

static
BOOL
IsExecutableFile(
	LPTSTR	pFileName	// IN
)
{

#define	EXECUTABLE_SUFFIX	_T(".exe")

	BOOL	bRet;
	DWORD	dwSuffixLen = sizeof(EXECUTABLE_SUFFIX)/sizeof(TCHAR) - 1;

	bRet =  FALSE;

	if (pFileName != NULL) {
		DWORD	dwFilePathLen = _tcslen(pFileName);
		if (dwFilePathLen >= dwSuffixLen) {
			if (_tcsicmp(pFileName + dwFilePathLen - dwSuffixLen, EXECUTABLE_SUFFIX) == 0) {
				bRet = TRUE;
			}
		}
	}

	return bRet;
}

static
BOOL
ExecUserAction(
	LPTSTR	pAppPath,
	LPTSTR	pArgs
)
{
	BOOL	bRet;

	bRet = FALSE;	// default return value

	if (pAppPath == NULL) {
		return FALSE;
	}

	if (IsExecutableFile(pAppPath)) {

		PROCESS_INFORMATION pi;

		memset(&pi, 0, sizeof(pi));

		bRet = CreateProcess(pAppPath, pArgs, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);

		if (bRet) {
			CloseHandle(pi.hThread);
			CloseHandle(pi.hProcess);
		}

	}
	else {
		SHELLEXECUTEINFO	sei;

		ZeroMemory(&sei, sizeof(SHELLEXECUTEINFO));

		sei.cbSize = sizeof(sei);
		sei.lpVerb = _T("Open");
		sei.lpFile = pAppPath;

		bRet = ShellExecuteEx(&sei);
	}


	return bRet;
}

static
ATOM
MyRegisterClass(
	HINSTANCE	hInstance,
	LPTSTR		szWindowClass
)
{
	WNDCLASS	wc;

    wc.style			= 0;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= 0;
    wc.hCursor			= 0;
    wc.hbrBackground	= 0;
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

static
BOOL
IsLandscape()
{
	int		nWidth;
	int		nHeight;
	BOOL	bRet;

	bRet = FALSE;

	nWidth = GetSystemMetrics(SM_CXSCREEN);
	nHeight = GetSystemMetrics(SM_CYSCREEN);

	if (nWidth > nHeight) {
		bRet = TRUE;
	}

	return bRet;
}

static
LRESULT
CALLBACK
WndProc(
	HWND	hWnd,
	UINT	message,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	static BOOL			s_bLandscape = FALSE;
	static CONFIGDATA	s_configData;

	switch (message) 
	{
		case WM_CREATE:
			{
				BOOL	bSucc = FALSE;
				TCHAR	szIniPath[MAX_PATH + 1];

				memset(&s_configData, 0, sizeof(s_configData));

				memset(szIniPath, 0, sizeof(szIniPath));
				if (GetIniPath(g_hModule, szIniPath)) {
					LoadConfigData(szIniPath, &s_configData);
				}

				s_bLandscape = IsLandscape();
			}
			break;

		case WM_DESTROY:
			DiscardConfigData(&s_configData);
			PostQuitMessage(0);
     		break;

		case WM_SETTINGCHANGE:
			if (wParam == SETTINGCHANGE_RESET) {
				BOOL	bNewLandscape;

				bNewLandscape = IsLandscape();
				if (s_bLandscape) {
					if (!bNewLandscape) {
						//  -> c
						if (s_configData.pOnPortraitApp != NULL && _tcslen(s_configData.pOnPortraitApp) != 0) {
							ExecUserAction(s_configData.pOnPortraitApp, s_configData.pOnPortraitArgs);
						}
					}
				}
				else {
					if (bNewLandscape) {
						// c -> 
						if (s_configData.pOnLandscapeApp != NULL && _tcslen(s_configData.pOnLandscapeApp) != 0) {
							ExecUserAction(s_configData.pOnLandscapeApp, s_configData.pOnLandscapeArgs);
						}
					}
				}

				s_bLandscape = bNewLandscape;
			}
     		break;

		case WM_APPEND_REQUEST:
			DestroyWindow(hWnd);
			break;

		case WM_RELOADCONFIG_REQUEST:
			{
				TCHAR	szIniPath[MAX_PATH + 1];

				memset(szIniPath, 0, sizeof(szIniPath));
				if (GetIniPath(g_hModule, szIniPath)) {
					DiscardConfigData(&s_configData);
					LoadConfigData(szIniPath, &s_configData);
				}
			}
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }

   return 0;
}


static
DWORD
WINAPI
WindowThread(void* pParam)
{
	if (pParam != NULL) {
		HWND	hWnd;
		WNDTHREAD_PARAM* pThreadParam;
		
		pThreadParam = (WNDTHREAD_PARAM*)pParam;

		MyRegisterClass(g_hModule, APP_CLASS_NAME);

		hWnd = CreateWindow(APP_CLASS_NAME, APP_TITLE_NAME, 0, 0, 0, 0, 0, NULL, NULL, g_hModule, NULL);

		if (hWnd != NULL) {
			MSG		msg;

			pThreadParam->bSuccess = TRUE;
			SetEvent(pThreadParam->hEvent);

			while (GetMessage(&msg, hWnd, 0, 0)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else {
			pThreadParam->bSuccess = FALSE;
			SetEvent(pThreadParam->hEvent);
		}
	}

	return 0;
}

static
void
CleanupWindowThread()
{
	if (g_hThread != NULL) {
		HWND	hWnd = NULL;

		hWnd = FindWindow(APP_CLASS_NAME, APP_TITLE_NAME);
		if (hWnd != NULL) {
			PostMessage(hWnd, WM_APPEND_REQUEST, 0, 0);
		}

		WaitForSingleObject(g_hThread, INFINITE);
		CloseHandle(g_hThread);
		g_hThread = NULL;
	}
}

BOOL
APIENTRY
DllMain(
	HANDLE hModule, 
	DWORD  ul_reason_for_call, 
	LPVOID lpReserved
)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		g_hModule = (HMODULE)hModule;
		break;
	case DLL_PROCESS_DETACH:
		CleanupWindowThread();
		g_hModule = NULL;
		break;
	}
    return TRUE;
}


DLLEXPORT
DWORD
JTEvent_PermitSpecVersion()
{
	return MAKEVERSION(MAJOR, MINOR, BUILD, REVISION);
}


DLLEXPORT
BOOL
JTEvent_Init()
{
	BOOL	bRet;
	HWND	hWnd;

	bRet = FALSE;

	hWnd = FindWindow(APP_CLASS_NAME, APP_TITLE_NAME);
	if (hWnd == NULL) {
		if (g_hThread == NULL) {

			WNDTHREAD_PARAM	param;

			memset(&param, 0, sizeof(param));
			param.bSuccess	= FALSE;
			param.hEvent	= CreateEvent(NULL, FALSE, FALSE, NULL);

			if (param.hEvent != NULL) {
				HANDLE			hThread;
				DWORD			dwThreadID;

				hThread = (HANDLE)CreateThread(NULL, 0, WindowThread, &param, 0, &dwThreadID);
				if (hThread != NULL) {
					WaitForSingleObject(param.hEvent, INFINITE);
					CloseHandle(param.hEvent);
					param.hEvent = NULL;

					if (param.bSuccess) {
						g_hThread = hThread;
						bRet = TRUE;
					}
					else {
						WaitForSingleObject(hThread, INFINITE);
						CloseHandle(hThread);
						hThread = NULL;
					}

				}
				else {
					CloseHandle(param.hEvent);
					param.hEvent = NULL;
				}
			}
		}
	}

	return TRUE;
}

DLLEXPORT
void
JTEvent_Close()
{
	CleanupWindowThread();
}

